﻿Type=Class
Version=2.52
@EndOfDesignText@

'Class module
Sub Class_Globals

	Public asView As ImageView 'the place to write over
	
	Private bUseAdiquity As Boolean
	Private bUseAdHub As Boolean
	Private bUseTapit As Boolean
	Private bShowMyAds As Boolean
	'adhub
	Private adBanner As AdHubBanner
	Private adSize As AdHubSize
	'adiquity
	Private ad As AdiquityAdView
	
	'tapit
	Private tapAd As TapitAd
	
	Private mapFilterTree As Map 'for picking which ad to display
	Private m_activity As Activity
	
	Private myAd As ImageView
	
	Private mapMyAds As Map 'to store the ads loaded In
	
	Private bAddedAd, bAddedAdHub, bAddedMyAd, bAddedTapIt As Boolean
	Private bStartedAd As Boolean
	
	Private tmrSwitchAds As Timer
	
	Type adInfo(marketLink As String, bmpAd As Bitmap)
	
	Dim mapNewFilterTree As Map
	
End Sub

'this class is to hold all the functions for adding adds to my apps
'will put in each type of company I hold an ad for
'and make it so that they all rotate around the same adspace
'that I make active
'options for counting up number of ads served
'and going from there
'don't forget to ad required stuff to Manifest File
'default switch rate is 15 seconds
Public Sub Initialize(DrawActivity As Activity)
	m_activity = DrawActivity
	tmrSwitchAds.Initialize("tmrSwitchAds" ,DateTime.TicksPerSecond * 15)
	mapMyAds.Initialize
	asView.Initialize("myAd")
	bAddedAd = False
	bAddedAdHub = False
	bAddedMyAd = False
	bStartedAd = False
End Sub

'adiquity Functions

Public Sub SetAdiquityCode(adCode As String, testMode As Boolean)
	ad.Initialize("ad", adCode, ad.ADSIZE_320x48)
	If testMode Then
		ad.SetTestMode
	End If
	bUseAdiquity = True
End Sub

'send 2011000001_001 for test code
Public Sub setAdHubCode(inventoryID As String)
	adBanner.Initialize("banner", inventoryID, adSize.BANNER, True)  
	bUseAdHub = True
End Sub

Public Sub setTapItCode(Zone_ID As String)
	tapAd.Initialize("Banner", Zone_ID)
	bUseTapit = True
End Sub


Public Sub StartAds
	SetFilterTree
	
	If bUseAdHub Then
		If Not(bAddedAdHub) Then
			m_activity.AddView(adBanner, asView.Left, asView.Top, asView.Width, asView.Height)
			bAddedAdHub = True
		End If
		adBanner.startAd
	End If
	
	If bUseAdiquity Then
		If Not(bAddedAd) Then
			m_activity.AddView(ad, asView.Left, asView.Top, asView.Width, asView.Height)
			bAddedAd = True
		End If
		If bStartedAd Then
			ad.resumeAds
		Else
			ad.StartAds
			bStartedAd = True
		End If
	End If
	
	If bUseTapit Then
		If Not(bAddedTapIt) Then
			m_activity.AddView(tapAd, asView.Left, asView.Top, asView.Width, asView.Height)
			bAddedTapIt = True
		End If
	End If
		
		
	
	
	If bShowMyAds Then
		If Not(bAddedMyAd) Then
			m_activity.AddView(myAd, asView.Left, asView.Top, asView.Width, asView.Height)
			bAddedMyAd = True
		End If
		setMyAd
		myAd.SendToBack
	End If
	asView.SendToBack
	tmrSwitchAds.Enabled = True
End Sub

Public Sub pauseAds
		
	tmrSwitchAds.Enabled = False
	ad.pauseAds
	adBanner.stopAd
		
End Sub

Public Sub resumeAds
	SetFilterTree
	tmrSwitchAds.Enabled = True
	ad.resumeAds
	adBanner.startAd
End Sub

Private Sub SetFilterTree

mapFilterTree.Initialize
mapNewFilterTree.Initialize
Dim TotalSize As Int
TotalSize = 0

If bUseAdiquity Then
	For i = 0 To 50
		mapFilterTree.Put(mapFilterTree.Size, "Adiquity")
	Next
	mapNewFilterTree.Put("Adiquity", 50)
	TotalSize = TotalSize + 50
End If

If bUseAdHub Then	
	For i = 0 To 50
		mapFilterTree.Put(mapFilterTree.Size, "AdHub")
	Next
	mapNewFilterTree.Put("AdHub", 50)
	TotalSize = TotalSize + 50
End If

If bUseTapit Then
	For i = 0 To 50
		mapFilterTree.Put(mapFilterTree.Size, "TapIt")
	Next
	mapNewFilterTree.Put("TapIt", 50)
	TotalSize = TotalSize + 50
End If

If bShowMyAds AND mapFilterTree.Size > 5 Then
	For i = 0 To mapFilterTree.Size*.1
		mapFilterTree.Put(mapFilterTree.Size, "MyAd")
	Next
	mapNewFilterTree.Put("MyAd", TotalSize * .1)
Else
	mapFilterTree.Put(mapFilterTree.Size, "MyAd")
	mapNewFilterTree.Put("MyAd", 10)
End If

End Sub

'to loadup all ads located in the File.dirAssets folder
'the filter is the first 4 or 5 characters of each PNG that is associated
'with that market link
Public Sub LoadMyAds(filterForAds As String, marketLink As String)

	myAd.Initialize("myAd")
	'need to load all the ads from file.dirassets that match
	Dim listAllFiles As List
	listAllFiles  = File.ListFiles(File.DirAssets)
	
	Dim listMyAds As List
	listMyAds.Initialize
	
	For Each str As String In listAllFiles
		If str.StartsWith(filterForAds) Then
			listMyAds.Add(str)
		End If
	Next
	
	'now go thru and make up a new set
	
	For Each str As String In listMyAds
		Dim newInfo As adInfo
		newInfo.Initialize
		newInfo.bmpAd = LoadBitmapSample(File.DirAssets, str, 320dip, 50dip)
		newInfo.marketLink = marketLink
		mapMyAds.Put(mapMyAds.Size, newInfo)
	Next
	
	If mapMyAds.Size  > 0 Then
			bShowMyAds = True
	End If
	
End Sub

'to rotate thru each ad
Private Sub tmrSwitchads_Tick
Dim SizeSoFar As Int
Dim SelectedCase As String
Dim TotalSize As Int

For i = 0 To mapNewFilterTree.Size -1
	TotalSize = TotalSize + mapNewFilterTree.GetValueAt(i)
Next

Dim result As Int
result = Rnd(0, TotalSize-1)

TotalSize = 0

Dim counter As Int
counter = 0
Do While result < = TotalSize
	SelectedCase = mapNewFilterTree.GetKeyAt(counter)
	TotalSize = TotalSize + mapNewFilterTree.GetValueAt(counter)
Loop

Select SelectedCase
	Case "Adiquity"
		adBanner.BringToFront
	Case "AdHub"
		ad.BringToFront
	Case "TapIt"
		tapAd.BringToFront
	Case "MyAd"
		myAd.BringToFront
End Select

Return

Dim result As Int
result = Rnd(0, mapFilterTree.Size)

If bShowMyAds Then
	setMyAd
End If

Select mapFilterTree.Get(result)
	Case "Adiquity"
		adBanner.BringToFront
	Case "AdHub"
		ad.BringToFront
	Case "MyAd"
		myAd.BringToFront
End Select


End Sub


'to set the current ad displayed from my loaded ads, if any
Private Sub setMyAd
	Dim result As Int
	result = Rnd(0, mapMyAds.Size)
	
	Dim thisAd As adInfo
	thisAd = mapMyAds.Get(result)
	myAd.Bitmap = thisAd.bmpAd
	myAd.Tag = thisAd
End Sub

Sub myAd_click
	Dim imag As ImageView
	imag = Sender
	
	If imag.Tag Is adInfo Then
		Dim newinfo As adInfo
		newinfo = imag.Tag
	Else
		Return
	End If

	Dim In As Intent
	In.Initialize(In.ACTION_VIEW, newinfo.marketLink)
	StartActivity(In)
End Sub
'tapit events
Sub Banner_failed(error As String)			'Subs called when an error has occured!
	Log("Banner Ad has failed to load" & " " & error)
End Sub

''' ---- !Adhub Banner Ads Events! ---- '
''Sub Banner_OnAdFailed(Message As String)   
'''Log("Error AdHub Banner: " & Message)
''ConstantsPrefs.g_iAdsRemaining = ConstantsPrefs.g_iAdsRemaining - 1
''End Sub
''Sub Banner_OnAdReceived  
'''Log("AdHub Banner received!")
''If ConstantsPrefs.g_iAdsRemaining < 0 Then
''	ConstantsPrefs.g_iAdsRemaining = 3
''Else
''	ConstantsPrefs.g_iAdsRemaining = ConstantsPrefs.g_iAdsRemaining + 3
''End If
''End Sub
''
''
'''adiquity
Sub ad_AdRequestFailed   
 Log("AdRequestFailed")

End Sub
Sub ad_AdRequestCompletedNoAd   
	Log("AdRequestCompletedNoAd")

End Sub
Sub ad_AdRequestCompleted  
Log("AdRequestCompleted")
'If ConstantsPrefs.g_iAdsRemaining < 0 Then
'	ConstantsPrefs.g_iAdsRemaining = 3
'Else
'	ConstantsPrefs.g_iAdsRemaining = ConstantsPrefs.g_iAdsRemaining + 3
'End If
End Sub